/***************************************************************************
 *   Copyright (C) 2011 by Renaud Guezennec                                *
 *   https://rolisteam.org/contact                   *
 *                                                                         *
 *   Rolisteam is free software; you can redistribute it and/or modify     *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef PATTERNMODEL_H
#define PATTERNMODEL_H

#include <QAbstractListModel>
#include <QPixmap>
#include <QStyledItemDelegate>

class PatternModel : public QAbstractListModel
{
    Q_OBJECT
public:
    PatternModel();

    QVariant data(const QModelIndex& index, int role= Qt::DisplayRole) const;
    int rowCount(const QModelIndex& parent= QModelIndex()) const;

    QPixmap getPatternAt(int i);

private:
    QList<QPixmap> m_list;
    QStringList m_listGrille;
};

#endif // PATTERNMODEL_H
